package require muzic

catch {console show ; wm withdraw .}

array set chan_def {
    0   1
    1   114
    2   6
    3   96
    4   24
    5   26
    6   32
    7   45
    8   9
    9   55
    10  15
    11  12
    12  46
    13  116
    14  105
    15  117
}

proc play {{font ""}} {
    global chan_def tcl_platform

    muzic::init
    if {$font eq ""} {
        if {$::muzic::builtin} {
            puts stderr "using builtin sound"
            set font builtin
        } else {
            puts -nonewline stderr "no built-in softsynth on $tcl_platform(os) - "
            set font default
        }
    }
    if {$font eq "default"} {
        # copy the sample SoundFont out of the VFS so that FluidSynth
        # can read it
        if {[info exists ::env(TEMP)]} {
            set tmp $::env(TEMP)
        } elseif {[info exists ::env(TMP)]} {
            set tmp $::env(TMP)
        } else {
            set tmp /tmp
        }
        set font [file join $tmp muzic-$::tcl_platform(user).sf2]
        file copy -force [file join $starkit::topdir default.sf2] $font
        puts stderr "using default SoundFont"
    }
    puts stderr "muzic::soundfont $font"
    muzic::soundfont $font
    foreach i [array names chan_def] {
        muzic::channel $i $chan_def($i)
    }
    foreach i [lsort -integer [array names chan_def]] {
        puts -nonewline stderr ":muzic::playnote $i 60 100"
        ::muzic::playnote $i 60 100
        after 1000 set continue 1
        vwait continue
        puts stderr ""
    }
}
