# 2007-12-31--02-41-25 HIYA



package require Tk
catch {console show}


set x [image create photo -width 500 -height 500]
pack [label .x -image $x -bd 0]

. conf -bg gray80
wm geom . 600x550


set shape_list {}


proc reverse_list list {
  set res {}
  set i [llength $list]
  while {$i > 0} {lappend res [lindex $list [incr i -1]]}
  set res
} ;# RS


proc add_to_shape_list {color x1 y1 x2 y2} {
  global shape_list
  lappend shape_list [list $color $x1 $y1 $x2 $y2]
}

proc draw_bg {} {
  global x
  $x put black -to 0 0 500 500
}

proc render {} {
  global shape_list
  global x
  draw_bg
  foreach el $shape_list {
    foreach {color x1 y1 x2 y2} $el break
    $x put $color -to $x1 $y1 $x2 $y2
  }
}

proc add_shape {color x1 y1 x2 y2} {
  add_to_shape_list $color $x1 $y1 $x2 $y2
  render
}

proc who_got_clicked {x y} {
  global shape_list
  set hit ""
  set reversed_list [reverse_list $shape_list]
  foreach el $reversed_list {
    foreach {color x1 y1 x2 y2} $el break
    if {($x >= $x1) && ($x <= $x2) &&
        ($y >= $y1) && ($y <= $y2)} {
      set hit $color
      break
    }
  }
  return $hit
}

proc move_shape {active_color nx ny} {

  global shape_list

  # go thru the shape_list, find the matching color (which doubles as ID),
  # and add nx,ny to its coords.

  set index 0
  foreach el $shape_list {
    foreach {color x1 y1 x2 y2} $el break
    if {$color eq $active_color} {
      set vx1 [expr {$x1 + $nx}] ; set vy1 [expr {$y1 + $ny}]
      set vx2 [expr {$x2 + $nx}] ; set vy2 [expr {$y2 + $ny}]
      break
    }
    incr index
  }

  if {($vx1 < 0) || ($vy1 < 0) || ($vx2 < 0) || ($vy2 < 0)} return

  set shape_list [lreplace $shape_list $index $index]

  add_shape $color $vx1 $vy1 $vx2 $vy2

}

proc clicked {X Y} {
  global active_shape
  global qx
  global qy

  set qx $X
  set qy $Y

  set x [expr $X - [winfo rootx .x]]
  set y [expr $Y - [winfo rooty .x]]
  set who [who_got_clicked $x $y]
  set active_shape $who
}

proc moving {X Y} {
  global active_shape
  global qx
  global qy

  if {$active_shape eq ""} return

  set nx [expr {$X - $qx}]
  set ny [expr {$Y - $qy}]
  set qx $X
  set qy $Y

  #puts "moved $active_shape by $nx $ny"

  move_shape $active_shape $nx $ny

}


bind .x <1>          [list clicked %X %Y]
bind .x <B1-Motion>  [list moving %X %Y]



# the ID for the shape and the color is one and the same,
# which means that you can only have unique colored shapes.
#
add_shape green   100 100 200 200
add_shape purple  150 150 250 250

